package ij2x.plugin.frame;

import ij2x.plugin.ColorIcon;
import javax.swing.BorderFactory;
import javax.swing.Icon;
import javax.swing.SwingUtilities;
import javax.swing.JLabel;
import javax.swing.JTabbedPane;
import java.awt.event.MouseEvent;
import java.awt.Color;
import java.awt.GridBagConstraints;
import java.awt.BorderLayout;
import java.beans.Beans;
import javax.swing.JPanel;
import java.awt.GridBagLayout;
import java.awt.Insets;
import java.awt.Component;
import javax.swing.border.Border;
import javax.swing.border.BevelBorder;

import java.awt.Cursor;
import java.awt.Graphics2D;
import java.awt.Dimension;
import java.awt.Graphics;
import java.awt.Font;
import java.awt.RenderingHints;

import ij.IJ;
import ij.ImageJ;
import ij.gui.Roi;

/**
 * <p>Title: </p>
 *
 * <p>Description: </p>
 *
 * <p>Copyright: Copyright (c) 2011</p>
 *
 * <p>Company: </p>
 *
 * @author not attributable
 * @version 1.0
 */
public class ColorSwatchs extends JPanel{
    private BorderLayout borderLayout1;

    protected static Color settingColor=Color.white;
    protected Color oldsettingColor;
    protected JPanel colorPane;
    protected JPanel colorPanel;
    protected JPanel palettePanel;

    protected GridBagLayout gridBagLayout1;
    protected JPanel[] jPanel = new JPanel[12];
    public JLabel tempLabel;
    public String colorHex;
    protected int maxColumn = 30;
    protected Border border1;
    protected String[] curstringRGB = new String[3];
    protected GridBagLayout gridBagLayout2 = new GridBagLayout();
    protected BorderLayout borderLayout2;
    protected BorderLayout borderLayout3;
    private static int tempColor=0, index;
    protected boolean pressed = true;
    public ColorIcon icon;
    public String[] stringRGB;
    private ColorSwatchArea colorIconArea = null;
    private BevelBorder bb ;//new BevelBorder for LOWER or RAISED type
    private Border grayBorder = BorderFactory.createBevelBorder(bb.RAISED, Color.gray, Color.lightGray);
    ColorPanelDemo cpDemo = new ColorPanelDemo(Roi.getColor());

    public ColorSwatchs() {
        try {
            jbInit();
        } catch (Exception ex) {
        }
    }
    public Color getSelectedColor(){
    return settingColor;
    }

    public void setSelectedColor(Color color){
      settingColor=color;
      oldsettingColor=settingColor;
     }

    public void setSelectedColor(JPanel panel, Color color){
        Border colorBorder = BorderFactory.createBevelBorder(bb.LOWERED, color, color);
        panel.setBorder(colorBorder);
    }
    private void jbInit() throws Exception {
      borderLayout1 = (BorderLayout) Beans.instantiate(getClass().getClassLoader(), BorderLayout.class.getName());
      colorPanel = (JPanel) Beans.instantiate(getClass().getClassLoader(), JPanel.class.getName());
      colorPane = (JPanel) Beans.instantiate(getClass().getClassLoader(), JPanel.class.getName());
      palettePanel = (JPanel) Beans.instantiate(getClass().getClassLoader(), JPanel.class.getName());
      gridBagLayout1 = (GridBagLayout) Beans.instantiate(getClass().getClassLoader(), GridBagLayout.class.getName());
      for(int i=0; i < jPanel.length; i++){
        jPanel[i] = (JPanel) Beans.instantiate(getClass().getClassLoader(),
                                               JPanel.class.getName());
      }
      tempLabel = (JLabel) Beans.instantiate(getClass().getClassLoader(), JLabel.class.getName());
      borderLayout2 = (BorderLayout) Beans.instantiate(getClass().getClassLoader(), BorderLayout.class.getName());
      borderLayout3 = (BorderLayout) Beans.instantiate(getClass().getClassLoader(), BorderLayout.class.getName());
      border1 = BorderFactory.createLineBorder(Color.black,1);
      this.setLayout(borderLayout1);
      if(colorIconArea == null){
        colorIconArea = new ColorSwatchArea();
      }
      createColorArea();
      palettePanel.setLayout(gridBagLayout1);
      palettePanel.setBorder(grayBorder);

      colorPanel.setLayout(new GridBagLayout());
      colorPane.setLayout(borderLayout3);
      int macOffset = 0;
      if(IJ.isMacintosh()){macOffset = 55;}
      else {macOffset = 40;}
      //colorPanel.add(palettePanel, BorderLayout.CENTER);
      //colorPanel.add(cpDemo, BorderLayout.SOUTH);
      colorPanel.add(palettePanel, new GridBagConstraints(0, 0, 1, 1, 0.0, 0.4
              ,GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(macOffset, 0, 0, 0), 0, 0));
      colorPanel.add(cpDemo, new GridBagConstraints(0, 1, 1, 1, 0.0, 0.3
              ,GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(0, 0, 0, 0), 0, 0));
      //colorPanel.add(ColorPane.instance.picker.publicPanel, new GridBagConstraints(0, 2, 1, 1, 0.0, 0.3
      //        ,GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(0, 0, 0, 0), 0, 0));

      
      colorPane.add(colorPanel, BorderLayout.CENTER);
      this.add(colorPane,  BorderLayout.CENTER);

      for(int i=2; i < jPanel.length; i++){
          palettePanel.add(jPanel[i], new GridBagConstraints(0, i - 1, 1, 1, 0.0, 0.0
                  , GridBagConstraints.CENTER, GridBagConstraints.NONE,
                  new Insets(0, 0, 0, 0), 0, 0));
      }
      cpDemo.addMouseListener(new java.awt.event.MouseListener() {
         public void mousePressed(MouseEvent e) {
                pressed = true;
      }

         public void mouseReleased(MouseEvent e) {
      }
         public void mouseClicked(MouseEvent e) {
               pressed=false;
               colorIconArea.colorLabel_mousePressed(e);
      }
         public void mouseEntered(MouseEvent e) {
        	 cpDemo.setCursor(new Cursor(Cursor.HAND_CURSOR));
        	 cpDemo.setToolTipText(
        			 Integer.toString(cpDemo.c.getRed())
                     +", "+Integer.toString(cpDemo.c.getGreen())
                        +", "+Integer.toString(cpDemo.c.getBlue())        			 
                           +", "+Integer.toString(cpDemo.c.getAlpha())        			 
                        );
         }
         public void mouseExited(MouseEvent e) {
        	 cpDemo.setCursor(new Cursor(Cursor.DEFAULT_CURSOR));        	 
         }
      });
      
      /*cpDemo.addMouseMotionListener(new java.awt.event.MouseMotionListener() {
        public void mouseMoved(MouseEvent e) {
	          colorIconArea.colorLabel_mouseMoved(e);
      }

        public void mouseDragged(MouseEvent e) {}
      });*/

      cpDemo.setBorder(grayBorder);
    }
    public void createColorArea(){
        final boolean isYellow = false;//basic color is yellow
      for(int i=2; i < 6; i++){
        colorIconArea.setPaletteColor(6-i, 2, isYellow);
        jPanel[i]=doGridbagLayout(colorIconArea.colorLabel0, maxColumn);
    }

        final boolean isCyan = true;// basic color is cyan
      for(int i=0; i < 5; i++){
        colorIconArea.setPaletteColor(i,0, isCyan);
        jPanel[i+6]=doGridbagLayout(colorIconArea.colorLabel0, maxColumn);
    }
        final boolean isGree = true;// basic color is gree
      for(int i=1; i < 2; i++){
        colorIconArea.setGrayPaletteColor(i, 2, isGree);
        jPanel[i+10]=doGridbagLayout(colorIconArea.colorLabel0, maxColumn);
    }
   }

  public JPanel doGridbagLayout(Component[] comp, int column){
     JPanel pan = new JPanel();
     GridBagLayout   gb = new GridBagLayout() ;
     GridBagConstraints c = new GridBagConstraints();
     pan.setLayout(gb);
     c.insets = new Insets(0,0,0,0);
     c.anchor = GridBagConstraints.CENTER;
     c.weighty = 0.0; c.weightx = 0.0;
     c.gridwidth = 1;
     for(int i=0;i<comp.length;i++){
         c.gridwidth =1;
         //System.out.println("(i%column) ="+(i%column));
         if(((i%column)-column+1)==0) c.gridwidth=GridBagConstraints.REMAINDER;
         gb.setConstraints(comp[i],c);
         pan.add(comp[i],c);
     }
     return pan;
  }
    public class ColorSwatchArea{
        int column = 6;
        int[] row = new int[column];
      int[] intColor = {0, 0, 0};
      JLabel[] colorLabel0 = new JLabel[(row.length-1)*column];

      Color[] color = new Color[column];
      Icon[] icon = new Icon[column];

      //default constructor
      public ColorSwatchArea(){
          for(int i=0; i < column; i++)
              row[i]=(column-1)*(i+1);
          for (int i = 0; i < colorLabel0.length; i++) {
              //colorLabel0[i]=new JLabel();
          }
      }

      public void setPaletteColor(int k, int block, boolean isCyan) {
        Color cyanColor=Color.CYAN;
        for (int i = 0; i < maxColumn; i++) {
          if (i < row[0]) {
            if (i == 0){
                cyanColor = isCyan ? new Color(0, 51 * k, 51 * k): new Color(51 * k, 0, 51 * k);
            setRGB(block, new Color(0, 51, 0), new Color(0, 255, 255), cyanColor);
          }
            setLabel(i, 0);
          }
          else if (i >= row[0] && i < row[1]) {
            if (i == row[0]){
                cyanColor = isCyan ? new Color(51 * k, 0, 51 * k): new Color(0, 51 * k, 51 * k);
            setRGB(block+1, new Color(51, 0, 0), new Color(255, 0, 255), cyanColor);
          }
            setLabel(i, row[0]);
          }
          else if (i >= row[1] && i < row[2]) {
            if (i == row[1]){
                cyanColor = isCyan ? new Color(51 * k, 0, 51 * k): new Color(51 * k, 51 * k, 0);
                setRGB(block, new Color(0, 0, 51), new Color(255, 0, 255), cyanColor);
          }
            setLabel(i, row[1]);
          }
          else if (i >= row[2] && i < row[3]) {
            if (i == row[2]){
                cyanColor = isCyan ? new Color(51 * k, 51 * k, 0): new Color(51 * k, 0, 51 * k);
            setRGB(block+1, new Color(0, 51, 0), new Color(255, 255, 0), cyanColor);
          }
            setLabel(i, row[2]);
          }
          else if (i >= row[3] && i < row[4]) {
            if (i == row[3]){
                cyanColor = isCyan ? new Color(51 * k, 51 * k, 0): new Color(0, 51 * k, 51 * k);
            setRGB(block, new Color(51, 0, 0), new Color(255, 255, 0), cyanColor);
          }
            setLabel(i, row[3]);
          }
          else if (i >= row[4] && i < row[5]) {
            if (i == row[4]){
                cyanColor = isCyan ? new Color(0, 51 * k, 51 * k): new Color(51 * k, 51 * k, 0);
           setRGB(block+1, new Color(0, 0, 51), new Color(0, 255, 255), cyanColor);
          }
            setLabel(i, row[4]);
          }

          colorLabel0[i].addMouseListener(new java.awt.event.
                                                MouseListener() {
                     public void mousePressed(MouseEvent e) {
                        pressed = true;
                     }

                     public void mouseReleased(MouseEvent e) {
                     }
                     public void mouseExited(MouseEvent e) {}
                     public void mouseClicked(MouseEvent e) {
                        pressed=false;
                        colorLabel_mousePressed(e);
                     }
                     public void mouseEntered(MouseEvent e) {
                     }
          });
          colorLabel0[i].addMouseMotionListener(new java.awt.event.
                                                MouseMotionListener() {
            public void mouseMoved(MouseEvent e) {
              //if(pressed)
              colorLabel_mouseMoved(e);
            }

            public void mouseDragged(MouseEvent e) {}
          });
          colorLabel0[i].setBorder(BorderFactory.createLineBorder(Color.lightGray,
              1));
        }
      }
      public void setGrayPaletteColor(int k, int block, boolean isCyan) {
        Color cyanColor=Color.CYAN;
        for (int i = 0; i < maxColumn; i++) {
          if (i < row[0]) {
            if (i == 0){
                cyanColor = isCyan ? new Color(51 * 0, 51 * 0, 51 * 0): new Color(51 * k, 0, 51 * k);
            setRGB(block, new Color(0, 0, 0), new Color(0, 0, 0), cyanColor);
          }
            setLabel(i, 0);
          }
          else if (i >= row[0] && i < row[1]) {
            if (i == row[0]){
                cyanColor = isCyan ? new Color(51 * k, 51 * k, 51 * k): new Color(0, 51 * k, 51 * k);
            setRGB(block+1, new Color(51, 51, 51), new Color(255, 255, 255), cyanColor);
          }
            setLabel(i, row[0]);
          }
          else if (i >= row[1] && i < row[2]) {
            if (i == row[1]){
                cyanColor = isCyan ? new Color(51 * k, 51 * k, 51 * k): new Color(51 * k, 51 * k, 0);
                setRGB(block, new Color(51, 51, 51), new Color(255, 255, 255), cyanColor);
          }
            setLabel(i, row[1]);
          }
          else if (i >= row[2] && i < row[3]) {
            if (i == row[2]){
                cyanColor = isCyan ? new Color(51 * k, 51 * k, 51 * k): new Color(51 * k, 0, 51 * k);
            setRGB(block+1, new Color(51, 51, 51), new Color(255, 255, 255), cyanColor);
          }
            setLabel(i, row[2]);
          }
          else if (i >= row[3] && i < row[4]) {
            if (i == row[3]){
                cyanColor = isCyan ? new Color(51 * k, 51 * k, 51 * k): new Color(0, 51 * k, 51 * k);
            setRGB(block, new Color(51, 51, 51), new Color(255, 255, 255), cyanColor);
          }
            setLabel(i, row[3]);
          }
          else if (i >= row[4] && i < row[5]) {
            if (i == row[4]){
                cyanColor = isCyan ? new Color(51 * k, 51 * k, 51 * k): new Color(51 * k, 51 * k, 0);
           setRGB(block+1, new Color(51, 51, 51), new Color(255, 255, 255), cyanColor);
          }
            setLabel(i, row[4]);
          }

          colorLabel0[i].addMouseListener(new java.awt.event.
                                                MouseListener() {
                     public void mousePressed(MouseEvent e) {
                        pressed = true;
                     }

                     public void mouseReleased(MouseEvent e) {
                     }
                     public void mouseExited(MouseEvent e) {}
                     public void mouseClicked(MouseEvent e) {
                        pressed=false;
                        colorLabel_mousePressed(e);
                     }
                     public void mouseEntered(MouseEvent e) {
                     }
          });
          colorLabel0[i].addMouseMotionListener(new java.awt.event.
                                                MouseMotionListener() {
            public void mouseMoved(MouseEvent e) {
              //if(pressed)
              colorLabel_mouseMoved(e);
            }

            public void mouseDragged(MouseEvent e) {}
          });
          colorLabel0[i].setBorder(BorderFactory.createLineBorder(Color.lightGray,
              1));
        }
      }
     void setLabel(int i, int col){
         if((i-col) < 0)i=col;
         icon[i - col] = new ColorIcon(color[i - col]);
         colorLabel0[i] = new JLabel(icon[i - col]);
         createIconToolTipText(colorLabel0[i], color[i - col]);
     }


      public void setRGB(int choose, Color rgb, Color rgbMax, Color rgbMin){

          int r=rgb.getRed();
          int g=rgb.getGreen();
          int b=rgb.getBlue();
          int maxr=rgbMax.getRed();
          int maxg=rgbMax.getGreen();
          int maxb=rgbMax.getBlue();
          int minr=rgbMin.getRed();
          int ming=rgbMin.getGreen();
          int minb=rgbMin.getBlue();
          int remeindr =0;
          int remeindg =0;
          int remeindb =0;
          int k = 0;
          int length= 0;
          if(minr >= 51)
          remeindr=minr/51;
          if(ming >= 51)
          remeindg=ming/51;
          if(minb >= 51)
          remeindb=minb/51;
          k=remeindr|remeindg|remeindb;
          //System.out.println("inc_k="+k);
          length = color.length-k;
        switch(choose){
        case 0:{
            for(int i = 0; i < length; i++){
                for(int j = 0; j < 3; j++){
                if(j==0)
                intColor[j]=(maxr-minr)-i*r;
                if(j==1)
                intColor[j]=(maxg-ming)-i*g;
                if(j==2)
                intColor[j]=(maxb-minb)-i*b;
                }
            color[i+k] = new Color(intColor[0], intColor[1], intColor[2]);
                }
                if(k ==1)color[0]=color[1];
                else if(k ==2){
                  for(int i=0; i < k; i++)
                    color[i]=color[k];
                   }
                else if(k ==3){
                  for(int i=0; i < k; i++)
                   color[i]=color[k];
                }
                else if(k ==4){
                  for(int i=0; i < k; i++)
                       color[i]=color[k];
                }
                else if(k ==5){
                  for(int i=0; i < k; i++)
                       color[i]=color[k];
                }
                break;
        }
        case 1:{
            for(int i = 0; i < length; i++){
                for(int j = 0; j < 3; j++){
                if(j==0)
                intColor[j]=(maxr-minr)-(length-i-1)*r;
                if(j==1)
                intColor[j]=(maxg-ming)-(length-i-1)*g;
                if(j==2)
                intColor[j]=(maxb-minb)-(length-i-1)*b;
                }
            color[i+k] = new Color(intColor[0], intColor[1], intColor[2]);
                }
                if(k ==1)color[0]=color[1];
                else if(k ==2){
                  for(int i=0; i < k; i++)
                    color[i]=color[k];
                   }
                else if(k ==3){
                  for(int i=0; i < k; i++)
                   color[i]=color[k];
                }
                else if(k ==4){
                  for(int i=0; i < k; i++)
                       color[i]=color[k];
                }
                else if(k ==5){
                  for(int i=0; i < k; i++)
                       color[i]=color[k];
                }
                break;
        }
        case 2:{
            for(int i = 0; i < length; i++){
                for(int j = 0; j < 3; j++){
                if(j==0)
                  if(r==0 && maxr == 0)intColor[j]=minr;
                else
                intColor[j]=(maxr-0)-i*r;
                if(j==1)
                  if(g==0 && maxg == 0)intColor[j]=ming;
                else
                intColor[j]=(maxg-0)-i*g;
                if(j==2)
                  if(b==0 && maxb == 0)intColor[j]=minb;
                else
                intColor[j]=(maxb-0)-i*b;
                }
            color[i] = new Color(intColor[0], intColor[1], intColor[2]);
                }
                if(k ==1)color[5]=color[4];
                else if(k ==2){
                  for(int i=0; i < k; i++)
                    color[5-i]=color[5-k];
                   }
                else if(k ==3){
                  for(int i=0; i < k; i++)
                   color[5-i]=color[5-k];
                }
                else if(k ==4){
                  for(int i=0; i < k; i++)
                       color[5-i]=color[5-k];
                }
                else if(k ==5){
                  for(int i=0; i < k; i++)
                       color[5-i]=color[5-k];
                }
                break;
        }
        case 3:{
            for(int i = 0; i < length; i++){
                for(int j = 0; j < 3; j++){
                if(j==0)
                  if(r==0 && maxr == 0)intColor[j]=minr;
                else
                intColor[j]=(maxr-0)-(length-i-1)*r;
                if(j==1)
                  if(g==0 && maxg == 0)intColor[j]=ming;
                else
                intColor[j]=(maxg-0)-(length-i-1)*g;
                if(j==2)
                  if(b==0 && maxb == 0)intColor[j]=minb;
                else
                intColor[j]=(maxb-0)-(length-i-1)*b;
                }
            color[i] = new Color(intColor[0], intColor[1], intColor[2]);
                }
                if(k ==1)color[5]=color[4];
                else if(k ==2){
                  for(int i=0; i < k; i++)
                    color[5-i]=color[5-k];
                   }
                else if(k ==3){
                  for(int i=0; i < k; i++)
                   color[5-i]=color[5-k];
                }
                else if(k ==4){
                  for(int i=0; i < k; i++)
                       color[5-i]=color[5-k];
                }
                else if(k ==5){
                  for(int i=0; i < k; i++)
                       color[5-i]=color[5-k];
                }
                break;
        }
        }

      }

      public void colorLabel_mouseMoved(MouseEvent e){
        JLabel colorLabel = null;
        if(e.getSource() instanceof JLabel)colorLabel=(JLabel)e.getSource();
        else return;
        tempLabel.setBorder(BorderFactory.createLineBorder(Color.lightGray, 1));
        tempLabel = colorLabel;
        //tempLabel.addMouseListener(this);
        colorLabel.setBorder(BorderFactory.createLineBorder(Color.white, 1));
        
        Color rgbColor = ((ColorIcon)colorLabel.getIcon()).getColor();

        settingColor = new Color(rgbColor.getRed(), rgbColor.getGreen(), rgbColor.getBlue(), ColorPane.instance.picker.getColor().getAlpha());
        StringBuffer hexValue = new StringBuffer();
        hexValue.append(Integer.toHexString(settingColor.getRGB()));
        colorHex = "0x"+hexValue.toString().toUpperCase();

        ColorPane.instance.setSelectedColor(settingColor);
        ColorPane.instance.picker.setColor(settingColor);
        cpDemo.setColor(settingColor);
        cpDemo.repaint();
      }

      public void colorLabel_mousePressed(MouseEvent e){

        if (!SwingUtilities.isRightMouseButton(e)){
            ColorPane.instance.colorChooice.setSelectedIndex(ColorPane.instance.picker.getMode());
            colorLabel_mouseMoved(e);
        }
      }
      // create color icon ToolTipText
      public JLabel createIconToolTipText(JLabel label, Color color){
        final JLabel colorLabel = label;
        colorLabel.setToolTipText(Integer.toString(color.getRed())
                              +", "+Integer.toString(color.getGreen())
                                 +", "+Integer.toString(color.getBlue())
                                   +", "+Integer.toString(color.getAlpha()));
        return colorLabel;
      }


    }

  }

  class ColorPanelDemo extends JPanel {
      Color c;
      static String name = ImageJ.PRODUCT_NAME+" "+ImageJ.VERSION;
      static int length = 220;
      static final int WIDTH=length, HEIGHT=60;
      Font font_14;
      ColorPanelDemo(Color c) {
          this.c = c;
          font_14 = new Font("Dialog",Font.PLAIN ,14);
      }

      public Dimension getPreferredSize() {
          return new Dimension(WIDTH, HEIGHT);
      }

      void setColor(Color c) {
          this.c = c;
      }

      public Dimension getMinimumSize() {
          return new Dimension(WIDTH, HEIGHT);
      }
      public void update(Graphics g) {
         paintComponent(g);
      }

      public void paintComponent(Graphics g) {
          super.paintComponent(g);
          Graphics2D g2D = (Graphics2D)g;
          g2D.setColor(c);
          g2D.fillRect(0, 0, WIDTH/8, HEIGHT);
          g2D.setColor(Color.black);
          g2D.fillRect(WIDTH/8, 0, WIDTH/8, HEIGHT);
          g2D.setColor(c);
          g2D.fillRect((WIDTH/4)+2, 0, (WIDTH/4+WIDTH/2), HEIGHT);
          g2D.setXORMode(g2D.getBackground());
          g2D.fillRect((WIDTH/4)+2+4, 4, (WIDTH/4+WIDTH/2)-10, HEIGHT-8);
          g2D.setColor(c);
          g2D.setFont(font_14);
          //g2D.setRenderingHint(RenderingHints.KEY_ANTIALIASING, RenderingHints.VALUE_ANTIALIAS_ON);
          g2D.drawString(name, WIDTH/4+10, HEIGHT/3+2);
          g2D.setColor(Color.black);
          g2D.drawString(name, WIDTH/4+10, HEIGHT/2+18);
      }

  }
